#include <windows.h>
#include <wininet.h>

#include <string>

namespace
{
    char *strerror_r(int errnum, char* buf, int len) {
        if (buf == NULL)
            return NULL;

        char *message;

        FormatMessage(
            FORMAT_MESSAGE_ALLOCATE_BUFFER |
            FORMAT_MESSAGE_FROM_SYSTEM,
            NULL,
            errnum,
            MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
            (char *)&message,
            0, NULL );

        sprintf_s(buf, len, "(%d) %s", errnum, message);

        LocalFree(message);
        return buf;
    }

    #define ERR_STRLEN 1024

    #define STRERR(bufname,errnum) \
        char bufname[ERR_STRLEN]; \
        strerror_r((errnum), bufname, ERR_STRLEN);

    std::string string_error(int errnum) {
        STRERR(errbuf, errnum);
        return std::string(errbuf);
    }
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd )
{
    HINTERNET ses=InternetOpen("ftpX v.0.0.0.1",INTERNET_OPEN_TYPE_DIRECT,0,0,0);
    if(!ses)
    {
        MessageBox(0,"Some error on InternetOpen [step 1]","ERROR",MB_ICONERROR);
        return -1;
    }

    HINTERNET hconnect = InternetConnect(ses, "localhost", 
        INTERNET_DEFAULT_FTP_PORT,
        "anonymous", "",
        INTERNET_SERVICE_FTP,INTERNET_FLAG_PASSIVE,0);
    if(!hconnect)
    {
        std::string error = "Some error on InternetConnect() [step 2]\n\t\"";
        error += string_error(GetLastError());
        error += "\"";

        MessageBox(0, error.c_str(), "ERROR", MB_ICONERROR);
        return -1;
    }
    
    if(!FtpPutFile(hconnect, "main.cpp", "incoming/main.cpp",
        FTP_TRANSFER_TYPE_BINARY, 0))
    {
        std::string error = "Some error on FtpPutFile() [step 3]\n\t\"";
        error += string_error(GetLastError());
        error += "\"";

        MessageBox(0, error.c_str(), "ERROR", MB_ICONERROR);
        return -1;
    }

    return 0;
}
